import {getPlayerProgress} from "./playerprogress.ts";
import {getHuntMode} from "./huntmode.ts";
import {getSleepModal} from "./sleepmodal.ts";
import {getVNModal} from "./vnmodal.ts";
import {getScorer} from "./scorer.ts";
import {getEndgameModal} from "./endgamemodal.ts";

const N_TURNS: number = 9;

export class StateManager {
  #turn: number;

  constructor() {
    this.#turn = 1;
  }

  getTurn(): number {
    return this.#turn
  }

  advance() {
    getSleepModal().setShown(false);

    if (this.#turn + 1 <= N_TURNS) {
      this.#turn += 1;
      getPlayerProgress().refill();
      getHuntMode().replaceMap();
    } else {
      // TODO: Play a specific scene
      let ending = getScorer().pickEnding();
      getVNModal().play(ending.scene);
      getEndgameModal().show(ending);
    }
  }

  getMaxTurns() {
    return N_TURNS
  }
}

let active: StateManager = new StateManager();
export function getStateManager(): StateManager {
  return active
}